; Librarie d'interfacage avec Ti-Gcc
;

_library:
	xdef	_library
_ti92plus
	xdef	_ti92plus
_ti89
	xdef	_ti89
	
	include "genlib.h"


	; Definitions des macros afin d'etre cool avec le C
func_new	macro
compt	set	4+5*4+6*4
	xdef	\1
\1	movem.l	d2-d7/a2-a6,-(a7)
	endm

rs	macro
\1	set	compt
compt	set	compt+\2
	endm	

func_end	macro
	movem.l	(a7)+,d2-d7/a2-a6
	rts
	endm


	; Les fonctions
	func_new	genclib@0000
	rs	Scr_adr,4
	rs	Hd_adr,2
	jsr	genlib::init_screen
	move.l	Scr_adr(a7),a1
	move.l	a0,(a1)
	move.l	Hd_adr(a7),a1
	move.w	d0,(a1)	
	func_end

	func_new	genclib@0001
	rs	Scr_adr,4
	rs	Hd_adr,2
	jsr	genlib::init_dscreen
	move.l	Scr_adr(a7),a1
	move.l	a0,(a1)
	move.l	Hd_adr(a7),a1
	move.w	d0,(a1)	
	func_end
		
	func_new	genclib@0002
	rs	Cond,2
	move.w	Cond(a7),d0
	jsr	genlib::set_filter
	func_end
	
	func_new	genclib@0003
	rs	x,2
	rs	y,2
	rs	color,2
	move.w	x(a7),d0
	move.w	y(a7),d1
	move.w	color(a7),d3
	jsr	genlib::put_pixel
	func_end

	func_new	genclib@0004
	rs	x,2
	rs	y,2
	rs	r,2
	rs	color,2
	move.w	x(a7),d4
	move.w	y(a7),d5
	move.w	color(a7),d3
	move.w	r(a7),d2
	jsr	genlib::draw_circle
	func_end
	
	func_new	genclib@0005
	rs	x,2
	rs	y,2
	rs	r,2
	rs	color,2
	move.w	x(a7),d4
	move.w	y(a7),d5
	move.w	color(a7),d3
	move.w	r(a7),d2
	jsr	genlib::draw_clipped_circle
	func_end

	func_new	genclib@0006
	rs	oct,1
	move.b	oct(a7),d0
	jsr	genlib::send_byte
	func_end
	
	func_new	genclib@0007
	rs	Buffer_recpt,4
	rs	Buffer_send,4
	rs	LenR,2
	rs	LenS,2
	move.w	LenR(a7),d0
	move.w	LenS(a7),d1
	move.l	Buffer_recpt(a7),a1
	move.l	Buffer_send(a7),a2
	jsr	genlib::set_link
	func_end
	
	func_new	genclib@0008
	rs	x,2
	rs	y,2
	move.w x(a7),genlib::sprite_scr_x
	move.w y(a7),genlib::sprite_scr_y
	func_end

	func_new	genclib@0009
	rs	adr,4
	move.l	adr(a7),genlib::sprite_tile_adr
	func_end

	func_new	genclib@000A
	rs	Scr,4
	rs	x,2
	rs	y,2
	rs	str,4
	move.l	Scr(a7),a1
	move.w	x(a7),d0
	move.w	y(a7),d1
	move.l	str(a7),a0
	jsr	genlib::put_small_string
	func_end
	
	func_new	genclib@000B
	rs	Scr,4
	rs	x,2
	rs	y,2
	rs	str,4
	move.l	Scr(a7),a1
	move.w	x(a7),d0
	move.w	y(a7),d1
	move.l	str(a7),a0
	jsr	genlib::put_medium_string
	func_end

	func_new	genclib@000C
	rs	Scr,4
	rs	x,2
	rs	y,2
	rs	str,4
	move.l	Scr(a7),a1
	move.w	x(a7),d0
	move.w	y(a7),d1
	move.l	str(a7),a0
	jsr	genlib::put_large_string
	func_end

	func_new	genclib@000D
	rs	x,2
	rs	y,2
	rs	bgs,4
	move.w	x(a7),d0
	move.w	y(a7),d1
	move.l	bgs(a7),a0
	jsr	genlib::put_big_sprite
	func_end

	func_new	genclib@000E
	rs	x,2
	rs	y,2
	rs	bgs,4
	rs	tmp,4
	move.w	x(a7),d0
	move.w	y(a7),d1
	move.l	bgs(a7),a0
	move.l	tmp(a7),a1
	jsr	genlib::put_big_sprite_flip_h
	func_end

	func_new	genclib@000F
	rs	x,2
	rs	y,2
	rs	bgs,4
	rs	tmp,4
	move.w	x(a7),d0
	move.w	y(a7),d1
	move.l	bgs(a7),a0
	move.l	tmp(a7),a1
	jsr	genlib::put_big_sprite_flip_v
	func_end

	func_new	genclib@0010
	rs	x,2
	rs	y,2
	rs	bgs,4
	rs	tmp,4
	move.w	x(a7),d0
	move.w	y(a7),d1
	move.l	bgs(a7),a0
	move.l	tmp(a7),a1
	jsr	genlib::put_big_sprite_flip_hv
	func_end

	func_new	genclib@0011
	rs	x,2
	rs	y,2
	rs	nbr,2
	move.w	x(a7),d0
	move.w	y(a7),d1
	move.w	nbr(a7),d2
	jsr	genlib::put_sprite_16
	func_end

	func_new	genclib@0012
	rs	x,2
	rs	y,2
	rs	nbr,2
	move.w	x(a7),d0
	move.w	y(a7),d1
	move.w	nbr(a7),d2
	jsr	genlib::put_sprite_16_flip_h
	func_end

	func_new	genclib@0013
	rs	x,2
	rs	y,2
	rs	nbr,2
	move.w	x(a7),d0
	move.w	y(a7),d1
	move.w	nbr(a7),d2
	jsr	genlib::put_sprite_16_flip_v
	func_end

	func_new	genclib@0014
	rs	x,2
	rs	y,2
	rs	nbr,2
	move.w	x(a7),d0
	move.w	y(a7),d1
	move.w	nbr(a7),d2
	jsr	genlib::put_sprite_16_flip_hv
	func_end

	func_new	genclib@0015
	rs	scr1,4
	rs	scr2,4
	rs	scr3,4
	move.l	scr1(a7),d0
	move.l	scr2(a7),d1
	move.l	scr3(a7),d2
	jsr	genlib::set_screen_int
	func_end

	func_new	genclib@0016
	rs	dscr,4
	move.l	dscr(a7),d0
	jsr	genlib::set_dscreen_int
	func_end

	func_new	genclib@0017
	rs	dscr,4
	move.l	dscr(a7),d0
	jsr	genlib::set_dscreen_function
	func_end

	func_new	genclib@0018
	rs	hd,2
	move.w	hd(a7),d0
	jsr	genlib::push_hd
	func_end

	func_new	genclib@0019
	rs	spr,4
	rs	fspr,4
	move.l	spr(a7),a0
	move.l	fspr(a7),a1
	jsr	genlib::make_fast_sprite
	func_end
	
	func_new	genclib@001A
	rs	map,4
	rs	tile,4
	rs	sizex,2
	move.l	map(a7),a3
	move.l	tile(a7),a4
	suba.l	a5,a5
	move.w	sizex(a7),d3
	jsr	genlib::init_plane
	func_end
	
	func_new	genclib@001B
	rs	plane,4
	move.l	plane(a7),a0
	jsr	genlib::free_plane
	func_end
	
	func_new	genclib@001C
	rs	plane,4
	move.l	plane(a7),a0
	jsr	genlib::refresh_plane
	func_end

	func_new	genclib@001D
	rs	plane,4
	move.l	plane(a7),a0
	jsr	genlib::copy_xyplane_xysprite
	func_end

	func_new	genclib@001E
	rs	plane,4
	rs	dscr,4
	move.l	plane(a7),a0
	move.l	dscr(a7),a1
	jsr	genlib::copy_dscreen_vscreen
	func_end

	func_new	genclib@001F
	rs	plane,4
	move.l	plane(a7),a0
	jsr	genlib::update_vscreen_8
	func_end

	func_new	genclib@0020
	rs	plane,4
	move.l	plane(a7),a0
	jsr	genlib::update_vscreen_16
	func_end

	func_new	genclib@0021
	rs	plane,4
	move.l	plane(a7),a0
	jsr	genlib::update_roll_vscreen_16
	func_end

	func_new	genclib@0022
	rs	plane,4
	move.l	plane(a7),a0
	jsr	genlib::update_vscreen_max16
	func_end

	func_new	genclib@0023
	rs	plane,4
	move.l	plane(a7),a0
	jsr	genlib::put_plane
	func_end

	func_new	genclib@0024
	rs	plane,4
	move.l	plane(a7),a0
	jsr	genlib::put_plane_89
	func_end

	func_new	genclib@0025
	rs	plane,4
	move.l	plane(a7),a0
	jsr	genlib::put_fgrd_plane
	func_end

	func_new	genclib@0026
	rs	plane,4
	move.l	plane(a7),a0
	jsr	genlib::put_fgrd_plane_89
	func_end

	func_new	genclib@0027
	rs	plane,4
	rs	dhz,4
	rs	hdz,4
	move.l	plane(a7),a0
	move.l	dhz(a7),a4
	move.l	hdz(a7),a5
	jsr	genlib::put_dhz_plane
	func_end

	func_new	genclib@0028
	rs	plane,4
	rs	dhz,4
	rs	hdz,4
	move.l	plane(a7),a0
	move.l	dhz(a7),a4
	move.l	hdz(a7),a5
	jsr	genlib::put_dhz_plane_89
	func_end

	func_new	genclib@0029
	rs	plane,4
	rs	dhz,4
	rs	hdz,4
	move.l	plane(a7),a0
	move.l	dhz(a7),a6
	move.l	hdz(a7),d7
	jsr	genlib::put_dhz_fgrd_plane
	func_end

	func_new	genclib@002A
	rs	plane,4
	rs	dhz,4
	rs	hdz,4
	move.l	plane(a7),a0
	move.l	dhz(a7),a6
	move.l	hdz(a7),d7
	jsr	genlib::put_dhz_fgrd_plane_89
	func_end

	func_new	genclib@002B
	rs	x,2
	rs	y,2
	rs	bgs,4
	rs	hf,4
	rs	vf,4
	move.l	bgs(a7),a1
	move.w	x(a7),d0
	move.w	y(a7),d1
	move.l	hf(a7),d4
	move.l	vf(a7),d5
	jsr	genlib::put_big_sprite_zoom
	func_end

	func_new	genclib@002C
	rs	x,2
	rs	y,2
	rs	no,2
	rs	hf,4
	rs	vf,4
	move.w	x(a7),d0
	move.w	y(a7),d1
	move.w	no(a7),d2
	move.l	hf(a7),d4
	move.l	vf(a7),d5
	jsr	genlib::put_big_sprite_zoom
	func_end

	func_new	genclib@002D
	rs	ptr1,4
	rs	ptr2,4
	rs	ptr3,4
	rs	scr,4
	move.l	ptr1(a7),a1
	move.l	ptr2(a7),a2
	move.l	ptr3(a7),a3
	move.l	scr(a7),a4
	jsr	genlib::draw_face
	func_end

	func_new	genclib@002E
	rs	ptr1,4
	rs	ptr2,4
	rs	ptr3,4
	rs	scr,4
	move.l	ptr1(a7),a1
	move.l	ptr2(a7),a2
	move.l	ptr3(a7),a3
	move.l	scr(a7),a4
	jsr	genlib::draw_clipped_face
	func_end

	func_new	genclib@002F
	rs	ptr1,4
	rs	ptr2,4
	rs	ptr3,4
	rs	color,2
	move.l	ptr1(a7),a1
	move.l	ptr2(a7),a2
	move.l	ptr3(a7),a3
	move.w	color(a7),d0
	jsr	genlib::draw_c_face
	func_end

	func_new	genclib@0030
	rs	ptr1,4
	rs	ptr2,4
	rs	ptr3,4
	rs	color,2
	move.l	ptr1(a7),a1
	move.l	ptr2(a7),a2
	move.l	ptr3(a7),a3
	move.w	color(a7),d0
	jsr	genlib::draw_clipped_c_face
	func_end

	func_new	genclib@0031
	rs	x,2
	rs	y,2
	rs	hf,4
	rs	vf,4
	rs	hw,2
	rs	vw,2
	rs	scr,4
	rs	text,4
	rs	text_inc,2
	
	move.w	hw(a7),d6
	swap	d6
	move.w	vw(a7),d6
	move.l	hf(a7),d4
	move.l	vf(a7),d5
	move.w	x(a7),d0
	move.w	y(a7),d1
	move.l	scr(a7),a0
	move.l	text(a7),a1
	lea	(30).w,a3
	move.w	text_inc(a7),a4
	jsr	genlib::do_zoom	
	func_end

	func_new	genclib@0032
	rs	x1_ptr,4
	rs	y1_ptr,4
	rs	x2_ptr,4
	rs	y2_ptr,4
	move.l	x1_ptr(a7),a0
	move.l	x2_ptr(a7),a2
	move.l	y1_ptr(a7),a1
	move.l	y2_ptr(a7),a3
	move.w	(a0),d0
	move.w	(a1),d1
	move.w	(a2),d2
	move.w	(a3),d3
	jsr	genlib::clip_line
	move.w	d0,(a0)
	move.w	d1,(a1)
	move.w	d2,(a2)
	move.w	d3,(a3)
	move.w	d4,d0
	func_end
	
	func_new	genclib@0033
	rs	x1,2
	rs	y1,2
	rs	x2,2
	rs	y2,2
	rs	color,2
	move.w	x1(a7),d0
	move.w	x2(a7),d2
	move.w	y1(a7),d1
	move.w	y2(a7),d3
	move.w	color(a7),d5
	jsr	genlib::draw_line
	func_end

	func_new	genclib@0034
	rs	x1,2
	rs	y1,2
	rs	x2,2
	rs	y2,2
	rs	color,2
	move.w	x1(a7),d0
	move.w	x2(a7),d2
	move.w	y1(a7),d1
	move.w	y2(a7),d3
	move.w	color(a7),d5
	jsr	genlib::draw_clipped_line
	func_end

	end
	